import java.io.*;
import java.util.*;
import krb5.lib.*;
import krb5.lib.util.*;
import krb5.lib.ccache.*;

class jkdestroy {
    
    static void printUsage() {
        System.out.println("Usage: java jkdestroy -h | -? | [-c cache_name]");
        System.out.println("\t-h and -? display help");
        System.out.println("\t-q");
    }

	public static void main(String args[]) {
	    boolean setQ = false;
	    int exitStatus = 0;
	    String cacheName = null;

	    Getopt getopt = new Getopt("c:h?", args);
	    if (getopt.invalidOptions()) {
	            System.out.println("jkdestroy: invalid option");
	            printUsage();
	            return;
	    }
	    
	    Dictionary opts = getopt.getOptTable();
	    Enumeration optsEnum = opts.keys();
	    while (optsEnum.hasMoreElements()) {
	        String opt = (String)optsEnum.nextElement();
	        if (opt.equals("h") || opt.equals("?")) {
	            printUsage();
	            return;
	        }
	        if (opt.equals("c")) {
	            cacheName = (String)opts.get("c");
	            if (cacheName == null || cacheName.length() == 0) {
	                printUsage();
	                return;
	            }
	        }
	    }

	    if (getopt.getTrailingArgs().length > 0) {
	        System.out.println("jkdestroy: too many args");
	        printUsage();
	        return;
	    }

	    try {
	        if (cacheName == null)
	            cacheName = Config.getDefaultCredentialsCacheName();
	        CredentialsCache ccache = Config.getCredentialsCache(cacheName);
	        ccache.destroy();
	        
	    } catch (KrbException e) {
	        System.out.println("jkdestroy: " + e.krbErrorMessage());
	    }
	}
}
