// Copyright 1997 The Open Group Research Institute.  All rights reserved.

package krb5.lib;

import krb5.lib.asn1.*;

/**
 * TGS request
 */
public class TGSReq extends KDCReq {

	/**
	 * Class constructor
	 *
	 * @param new_pAData is of type PAData[]
	 * @param new_reqBody is of type KDCReqBody
	 * @see krb5.lib.PAData
	 * @see krb5.lib.KDCReqBody
	 */
	public TGSReq(PAData[] new_pAData, KDCReqBody new_reqBody) {
		super(new_pAData, new_reqBody, Krb5.KRB_TGS_REQ);
	}

	/**
	 * Class constructor
	 *
	 * @param data is of type byte[]
	 * @exception Asn1Exception an exception
	 * @exception BitStringException an exception
	 * @exception RealmException an exception
	 * @exception KrbApErrException an exception
	 * @see krb5.lib.Asn1Exception
	 * @see krb5.lib.BitStringException
	 * @see krb5.lib.RealmException
	 * @see krb5.lib.KrbApErrException
	 */
	public TGSReq(byte[] data) throws Asn1Exception,
		BitStringException, RealmException, KrbApErrException {
		this(new EncodeRef(data));
	}

	/**
	 * Class constructor
	 *
	 * @param ref is of type EncodeRef
	 * @exception Asn1Exception an exception
	 * @exception BitStringException an exception
	 * @exception RealmException an exception
	 * @exception KrbApErrException an exception
	 * @see krb5.lib.asn1.EncodeRef
	 * @see krb5.lib.Asn1Exception
	 * @see krb5.lib.BitStringException
	 * @see krb5.lib.RealmException
	 * @see krb5.lib.KrbApErrException
	 */
	public TGSReq(EncodeRef ref) throws Asn1Exception,
		BitStringException, RealmException, KrbApErrException {
		super(ref, Krb5.KRB_TGS_REQ);
	}

}