// Copyright 1997 The Open Group Research Institute.  All rights reserved.

package krb5.lib.crypto;

import krb5.lib.*;

public class NullEType extends EType {

	public NullEType() {
	}

	public int eType() {
		return Krb5.ETYPE_NULL;
	}

	public int minimumPadSize() {
		return 0;
	}

	public int confounderSize() {
		return 0;
	}

	public int checksumType() {
		return Krb5.CKSUMTYPE_NULL;
	}

	public int checksumSize() {
		return 0;
	}

	public int blockSize() {
		return 1;
	}

	public int keyType() {
		return Krb5.KEYTYPE_NULL;
	}

	public int keySize() {
		return 0;
	}

	public byte[] encrypt(byte[] data, byte[] key) {
		byte[] cipher = new byte[data.length];
		System.arraycopy(data, 0, cipher, 0, data.length);
		return cipher;
	}

	public byte[] encrypt(byte[] data, byte[] key, byte[] ivec) {
		byte[] cipher = new byte[data.length];
		System.arraycopy(data, 0, cipher, 0, data.length);
		return cipher;
	}

	public void decrypt(byte[] cipher, byte[] key)
		throws KrbApErrException {
	}

	public void decrypt(byte[] cipher, byte[] key, byte[] ivec)
		throws KrbApErrException {
	}

	public byte[] calculateChecksum(byte[] data, int size) {
		return null;
	}

}

